blob: e2e2c895983013a2f2ad84795c8b7888234f768f [file] [log] [blame]
Tristan Muntsinger82c10502019-10-15 14:49:19 -07001#!/bin/bash
2
3# Copyright 2019 Google Inc. All rights reserved.
4
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8
9# http://www.apache.org/licenses/LICENSE-2.0
10
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17source "${ANDROID_BUILD_TOP}/external/shflags/src/shflags"
18
Tristan Muntsinger34569112019-10-16 22:10:54 -070019DEFINE_boolean p1 \
20 false "Only generate/write the 1st partition (loader1)" "1"
21DEFINE_boolean p2 \
22 false "Only generate/write the 2nd partition (env)" "2"
23DEFINE_boolean p3 \
24 false "Only generate/write the 3rd partition (loader2)" "3"
25DEFINE_boolean p4 \
26 false "Only generate/write the 4th partition (trust)" "4"
27DEFINE_boolean p5 \
28 false "Only generate/write the 5th partition (rootfs)" "5"
29
30FLAGS_HELP="USAGE: $0 <KERNEL_DIR> [IMAGE] [flags]"
Tristan Muntsinger82c10502019-10-15 14:49:19 -070031
32FLAGS "$@" || exit $?
33eval set -- "${FLAGS_ARGV}"
34
Tristan Muntsinger34569112019-10-16 22:10:54 -070035if [ ${FLAGS_p1} -eq ${FLAGS_FALSE} ] &&
36 [ ${FLAGS_p2} -eq ${FLAGS_FALSE} ] &&
37 [ ${FLAGS_p3} -eq ${FLAGS_FALSE} ] &&
38 [ ${FLAGS_p4} -eq ${FLAGS_FALSE} ] &&
39 [ ${FLAGS_p5} -eq ${FLAGS_FALSE} ]; then
40 FLAGS_p1=${FLAGS_TRUE}
41 FLAGS_p2=${FLAGS_TRUE}
42 FLAGS_p3=${FLAGS_TRUE}
43 FLAGS_p4=${FLAGS_TRUE}
44 FLAGS_p5=${FLAGS_TRUE}
45fi
46
Tristan Muntsinger82c10502019-10-15 14:49:19 -070047for arg in "$@" ; do
48 if [ -z $KERNEL_DIR ]; then
49 KERNEL_DIR=$arg
50 elif [ -z $IMAGE ]; then
51 IMAGE=$arg
52 else
53 flags_help
54 exit 1
55 fi
56done
57
Tristan Muntsingere4eeded2019-10-15 20:26:15 -070058USE_IMAGE=`[ -z "${IMAGE}" ] && echo "0" || echo "1"`
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -070059OVERWRITE=`[ -e "${IMAGE}" ] && echo "1" || echo "0"`
60if [ -z $KERNEL_DIR ]; then
Tristan Muntsinger82c10502019-10-15 14:49:19 -070061 flags_help
62 exit 1
63fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -070064if [ ! -e "${KERNEL_DIR}" ]; then
65 echo "error: can't find '${KERNEL_DIR}'. aborting..."
66 exit 1
67fi
68
69# escalate to superuser
70if [ $UID -ne 0 ]; then
71 cd ${ANDROID_BUILD_TOP}
72 . ./build/envsetup.sh
73 lunch ${TARGET_PRODUCT}-${TARGET_BUILD_VARIANT}
74 mmma external/u-boot
75 cd -
76 exec sudo -E "${0}" ${@}
77fi
78
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -070079if [ $OVERWRITE -eq 1 ]; then
80 OVERWRITE_IMAGE=${IMAGE}
81 IMAGE=`mktemp`
82fi
83
Tristan Muntsingere4eeded2019-10-15 20:26:15 -070084if [ $USE_IMAGE -eq 0 ]; then
85 init_devs=`lsblk --nodeps -oNAME -n`
86 echo "Reinsert device (to write to) into PC"
87 while true; do
88 devs=`lsblk --nodeps -oNAME -n`
89 new_devs="$(echo -e "${init_devs}\n${devs}" | sort | uniq -u | awk 'NF')"
90 num_devs=`echo "${new_devs}" | wc -l`
91 if [[ "${new_devs}" == "" ]]; then
92 num_devs=0
93 fi
94 if [[ ${num_devs} -gt 1 ]]; then
95 echo "error: too many new devices detected! aborting..."
96 exit 1
97 fi
98 if [[ ${num_devs} -eq 1 ]]; then
99 if [[ "${new_devs}" != "${mmc_dev}" ]]; then
100 if [[ "${mmc_dev}" != "" ]]; then
101 echo "error: block device name mismatch ${new_devs} != ${mmc_dev}"
102 echo "Reinsert device (to write to) into PC"
103 fi
104 mmc_dev=${new_devs}
105 continue
106 fi
107 echo "${init_devs}" | grep "${mmc_dev}" >/dev/null
108 if [[ $? -eq 0 ]]; then
109 init_devs="${devs}"
110 continue
111 fi
112 break
113 fi
114 done
115 # now inform the user
116 echo "Detected device at /dev/${mmc_dev}"
117fi
118
Tristan Muntsinger34569112019-10-16 22:10:54 -0700119if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
120 cd ${ANDROID_BUILD_TOP}/external/arm-trusted-firmware
121 CROSS_COMPILE=aarch64-linux-gnu- make PLAT=rk3399 DEBUG=0 ERROR_DEPRECATED=1 bl31
122 export BL31="${ANDROID_BUILD_TOP}/external/arm-trusted-firmware/build/rk3399/release/bl31/bl31.elf"
123 cd -
124fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700125
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700126cd ${ANDROID_BUILD_TOP}/external/u-boot
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700127
Tristan Muntsinger34569112019-10-16 22:10:54 -0700128if [ ${FLAGS_p2} -eq ${FLAGS_TRUE} ]; then
129 tmpfile=`mktemp`
130 bootenv=`mktemp`
131 cat > ${tmpfile} << "EOF"
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700132bootdelay=2
133baudrate=1500000
134scriptaddr=0x00500000
135boot_targets=mmc1 mmc0
136bootcmd=run distro_bootcmd
137distro_bootcmd=for target in ${boot_targets}; do run bootcmd_${target}; done
138bootcmd_mmc0=devnum=0; run mmc_boot
139bootcmd_mmc1=devnum=1; run mmc_boot
140mmc_boot=if mmc dev ${devnum}; then ; run scan_for_boot_part; fi
141scan_for_boot_part=part list mmc ${devnum} -bootable devplist; env exists devplist || setenv devplist 1; for part in ${devplist}; do if fstype mmc ${devnum}:${part} bootfstype; then run find_init_script; fi; done; setenv devplist
142find_init_script=if test -e mmc ${devnum}:${part} /boot/init.scr; then echo Found U-Boot script /boot/init.scr; run init_scr; fi
143init_scr=load mmc ${devnum}:${part} ${scriptaddr} /boot/init.scr; source ${scriptaddr}
144EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700145 ${ANDROID_HOST_OUT}/bin/mkenvimage -s 32768 -o ${bootenv} - < ${tmpfile}
146fi
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700147
Tristan Muntsinger34569112019-10-16 22:10:54 -0700148if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ] || [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
149 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- rock-pi-4-rk3399_defconfig
150 if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
151 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- -j`nproc`
152 fi
153 if [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
154 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- u-boot.itb
155 fi
156 if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
157 idbloader=`mktemp`
158 ${ANDROID_HOST_OUT}/bin/mkimage -n rk3399 -T rksd -d tpl/u-boot-tpl.bin ${idbloader}
159 cat spl/u-boot-spl.bin >> ${idbloader}
160 fi
161fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700162cd -
163
Tristan Muntsinger34569112019-10-16 22:10:54 -0700164if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
165 ${ANDROID_BUILD_TOP}/kernel/tests/net/test/build_rootfs.sh -a arm64 -s buster -n ${IMAGE}
166 if [ $? -ne 0 ]; then
167 echo "error: failed to build rootfs. exiting..."
168 exit 1
169 fi
170 truncate -s +3G ${IMAGE}
171 e2fsck -f ${IMAGE}
172 resize2fs ${IMAGE}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700173
Tristan Muntsinger34569112019-10-16 22:10:54 -0700174 mntdir=`mktemp -d`
175 mount ${IMAGE} ${mntdir}
176 if [ $? != 0 ]; then
177 echo "error: unable to mount ${IMAGE} ${mntdir}"
178 exit 1
179 fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700180
Tristan Muntsinger34569112019-10-16 22:10:54 -0700181 cat > ${mntdir}/boot/init.cmd << "EOF"
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700182mmc dev 1 0; mmc read 0x02080000 0x1fc0 0x40;
183ethaddr=$ethaddr
184env default -a
185setenv ethaddr $ethaddr
186setenv boot_targets 'mmc1 mmc0 usb0 pxe'
187saveenv
188mmc dev 1 0; mmc read 0x04000000 0x1fc0 0x40;
189mmc dev 0 0; mmc write 0x04000000 0x1fc0 0x40;
190mmc dev 1 0; mmc write 0x02080000 0x1fc0 0x40;
191EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700192 ${ANDROID_BUILD_TOP}/external/u-boot/tools/mkimage \
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700193 -C none -A arm -T script -d ${mntdir}/boot/init.cmd ${mntdir}/boot/init.scr
194
Tristan Muntsinger34569112019-10-16 22:10:54 -0700195 cat > ${mntdir}/boot/boot.cmd << "EOF"
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700196load mmc ${devnum}:${distro_bootpart} 0x02080000 /boot/Image
197load mmc ${devnum}:${distro_bootpart} 0x04000000 /boot/uInitrd
198load mmc ${devnum}:${distro_bootpart} 0x01f00000 /boot/dtb/rockchip/rk3399-rock-pi-4.dtb
199setenv finduuid "part uuid mmc ${devnum}:${distro_bootpart} uuid"
200run finduuid
201setenv bootargs "earlycon=uart8250,mmio32,0xff1a0000 console=ttyS2,1500000n8 loglevel=7 root=PARTUUID=${uuid} rootwait rootfstype=ext4 sdhci.debug_quirks=0x20000000"
202booti 0x02080000 0x04000000 0x01f00000
203EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700204 ${ANDROID_HOST_OUT}/bin/mkimage \
205 -C none -A arm -T script -d ${mntdir}/boot/boot.cmd ${mntdir}/boot/boot.scr
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700206
Tristan Muntsinger34569112019-10-16 22:10:54 -0700207 cd ${KERNEL_DIR}
208 export PATH=${ANDROID_BUILD_TOP}/prebuilts/clang/host/linux-x86/clang-r353983c/bin:$PATH
209 export PATH=${ANDROID_BUILD_TOP}/prebuilts/gcc/linux-x86/aarch64/aarch64-linux-android-4.9/bin:$PATH
210 make ARCH=arm64 CC=clang CROSS_COMPILE=aarch64-linux-androidkernel- \
211 CLANG_TRIPLE=aarch64-linux-gnu- rockpi4_defconfig
212 make ARCH=arm64 CC=clang CROSS_COMPILE=aarch64-linux-androidkernel- \
213 CLANG_TRIPLE=aarch64-linux-gnu- -j`nproc`
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700214
Tristan Muntsinger34569112019-10-16 22:10:54 -0700215 cp ${KERNEL_DIR}/arch/arm64/boot/Image ${mntdir}/boot/
216 mkdir -p ${mntdir}/boot/dtb/rockchip/
217 cp ${KERNEL_DIR}/arch/arm64/boot/dts/rockchip/rk3399-rock-pi-4.dtb ${mntdir}/boot/dtb/rockchip/
218 cd -
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700219
Tristan Muntsinger34569112019-10-16 22:10:54 -0700220 mount -o bind /proc ${mntdir}/proc
221 mount -o bind /sys ${mntdir}/sys
222 mount -o bind /dev ${mntdir}/dev
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700223
Tristan Muntsinger34569112019-10-16 22:10:54 -0700224 echo "Installing required packages..."
225 chroot ${mntdir} /bin/bash <<EOF
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700226apt-get update
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700227apt-get install -y -f initramfs-tools u-boot-tools network-manager openssh-server sudo man-db vim git dpkg-dev cdbs debhelper config-package-dev gdisk eject lzop binfmt-support ntpdate
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700228EOF
229
Tristan Muntsinger34569112019-10-16 22:10:54 -0700230 echo "Turning on DHCP client..."
231 cat >${mntdir}/etc/systemd/network/dhcp.network <<EOF
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700232[Match]
233Name=en*
234
235[Network]
236DHCP=yes
237EOF
238
Tristan Muntsinger34569112019-10-16 22:10:54 -0700239 chroot ${mntdir} /bin/bash << "EOT"
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700240echo "Adding user vsoc-01 and groups..."
241useradd -m -G kvm,sudo -d /home/vsoc-01 --shell /bin/bash vsoc-01
242echo -e "cuttlefish\ncuttlefish" | passwd
243echo -e "cuttlefish\ncuttlefish" | passwd vsoc-01
244EOT
245
Tristan Muntsinger34569112019-10-16 22:10:54 -0700246 echo "Cloning android-cuttlefish..."
247 cd ${mntdir}/home/vsoc-01
248 git clone https://github.com/google/android-cuttlefish.git
249 cd -
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700250
Tristan Muntsinger34569112019-10-16 22:10:54 -0700251 echo "Creating led script..."
252 cat > ${mntdir}/usr/local/bin/led << "EOF"
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700253#!/bin/bash
254
255if [ "$1" == "--start" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700256 echo 125 > /sys/class/gpio/export
257 echo out > /sys/class/gpio/gpio125/direction
258 chmod 666 /sys/class/gpio/gpio125/value
259 echo 0 > /sys/class/gpio/gpio125/value
260 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700261fi
262
263if [ "$1" == "--stop" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700264 echo 0 > /sys/class/gpio/gpio125/value
265 echo 125 > /sys/class/gpio/unexport
266 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700267fi
268
269if [ ! -e /sys/class/gpio/gpio125/value ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700270 echo "error: led service not initialized"
271 exit 1
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700272fi
273
274if [ "$1" == "0" ] || [ "$1" == "off" ] || [ "$1" == "OFF" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700275 echo 0 > /sys/class/gpio/gpio125/value
276 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700277fi
278
279if [ "$1" == "1" ] || [ "$1" == "on" ] || [ "$1" == "ON" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700280 echo 1 > /sys/class/gpio/gpio125/value
281 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700282fi
283
284echo "usage: led <0|1>"
285exit 1
286EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700287 chown root:root ${mntdir}/usr/local/bin/led
288 chmod 755 ${mntdir}/usr/local/bin/led
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700289
Tristan Muntsinger34569112019-10-16 22:10:54 -0700290 echo "Creating led service..."
291 cat > ${mntdir}/etc/systemd/system/led.service << EOF
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700292[Unit]
293 Description=led service
294 ConditionPathExists=/usr/local/bin/led
295
296[Service]
297 Type=oneshot
298 ExecStart=/usr/local/bin/led --start
299 ExecStop=/usr/local/bin/led --stop
300 RemainAfterExit=true
301 StandardOutput=journal
302
303[Install]
304 WantedBy=multi-user.target
305EOF
306
Tristan Muntsinger34569112019-10-16 22:10:54 -0700307 echo "Creating SD duplicator script..."
308 cat > ${mntdir}/usr/local/bin/sd-dupe << "EOF"
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700309#!/bin/bash
310led 0
311
312src_dev=mmcblk0
313dest_dev=mmcblk1
314part_num=p5
315
316if [ -e /dev/mmcblk0p5 ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700317 led 1
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700318
Tristan Muntsinger34569112019-10-16 22:10:54 -0700319 sgdisk -Z -a1 /dev/${dest_dev}
320 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 /dev/${dest_dev}
321 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env /dev/${dest_dev}
322 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 /dev/${dest_dev}
323 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust /dev/${dest_dev}
324 sgdisk -a1 -n:5:32768:- -A:5:set:2 -t:5:8305 -c:5:rootfs /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700325
Tristan Muntsinger34569112019-10-16 22:10:54 -0700326 src_block_count=`tune2fs -l /dev/${src_dev}${part_num} | grep "Block count:" | sed 's/.*: *//'`
327 src_block_size=`tune2fs -l /dev/${src_dev}${part_num} | grep "Block size:" | sed 's/.*: *//'`
328 src_fs_size=$(( src_block_count*src_block_size ))
329 src_fs_size_m=$(( src_fs_size / 1024 / 1024 + 1 ))
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700330
Tristan Muntsinger34569112019-10-16 22:10:54 -0700331 dd if=/dev/${src_dev}p1 of=/dev/${dest_dev}p1 conv=sync,noerror status=progress
332 dd if=/dev/${src_dev}p2 of=/dev/${dest_dev}p2 conv=sync,noerror status=progress
333 dd if=/dev/${src_dev}p3 of=/dev/${dest_dev}p3 conv=sync,noerror status=progress
334 dd if=/dev/${src_dev}p4 of=/dev/${dest_dev}p4 conv=sync,noerror status=progress
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700335
Tristan Muntsinger34569112019-10-16 22:10:54 -0700336 echo "Writing ${src_fs_size_m} MB: /dev/${src_dev} -> /dev/${dest_dev}..."
337 dd if=/dev/${src_dev}${part_num} of=/dev/${dest_dev}${part_num} bs=1M conv=sync,noerror status=progress
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700338
Tristan Muntsinger34569112019-10-16 22:10:54 -0700339 echo "Expanding /dev/${dest_dev}${part_num} filesystem..."
340 e2fsck -fy /dev/${dest_dev}${part_num}
341 resize2fs /dev/${dest_dev}${part_num}
342 tune2fs -O has_journal /dev/${dest_dev}${part_num}
343 e2fsck -fy /dev/${dest_dev}${part_num}
344 sync /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700345
Tristan Muntsinger34569112019-10-16 22:10:54 -0700346 echo "Cleaning up..."
347 mount /dev/${dest_dev}${part_num} /media
348 chroot /media /usr/local/bin/install-cleanup
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700349
Tristan Muntsinger34569112019-10-16 22:10:54 -0700350 if [ $? == 0 ]; then
351 echo "Successfully copied Rock Pi image!"
352 while true; do
353 led 1; sleep 0.5
354 led 0; sleep 0.5
355 done
356 else
357 echo "Error while copying Rock Pi image"
358 while true; do
359 led 1; sleep 0.1
360 led 0; sleep 0.1
361 done
362 fi
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700363else
Tristan Muntsinger34569112019-10-16 22:10:54 -0700364 echo "Expanding /dev/${dest_dev}${part_num} filesystem..."
365 e2fsck -fy /dev/${dest_dev}${part_num}
366 resize2fs /dev/${dest_dev}${part_num}
367 tune2fs -O has_journal /dev/${dest_dev}${part_num}
368 e2fsck -fy /dev/${dest_dev}${part_num}
369 sync /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700370
Tristan Muntsinger34569112019-10-16 22:10:54 -0700371 echo "Cleaning up..."
372 /usr/local/bin/install-cleanup
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700373fi
374EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700375 chmod +x ${mntdir}/usr/local/bin/sd-dupe
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700376
Tristan Muntsinger34569112019-10-16 22:10:54 -0700377 echo "Creating SD duplicator service..."
378 cat > ${mntdir}/etc/systemd/system/sd-dupe.service << EOF
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700379[Unit]
380 Description=Duplicate SD card rootfs to eMMC on Rock Pi
381 ConditionPathExists=/usr/local/bin/sd-dupe
382 After=led.service
383
384[Service]
385 Type=simple
386 ExecStart=/usr/local/bin/sd-dupe
387 TimeoutSec=0
388 StandardOutput=tty
389
390[Install]
391 WantedBy=multi-user.target
392EOF
393
Tristan Muntsinger34569112019-10-16 22:10:54 -0700394 echo "Creating cleanup script..."
395 cat > ${mntdir}/usr/local/bin/install-cleanup << "EOF"
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700396#!/bin/bash
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700397echo "Installing cuttlefish-common package..."
398echo "nameserver 8.8.8.8" > /etc/resolv.conf
399MAC=`ip link | grep eth0 -A1 | grep ether | sed 's/.*\(..:..:..:..:..:..\) .*/\1/'`
400sed -i " 1 s/.*/& rockpi-${MAC}/" /etc/hosts
401sudo hostnamectl set-hostname "rockpi-${MAC}"
402
403dpkg --add-architecture amd64
404until ping -c1 ftp.debian.org; do sleep 1; done
405ntpdate time.google.com
406while true; do
407 apt-get -o Acquire::Check-Valid-Until=false update
408 if [ $? != 0 ]; then sleep 1; continue; fi
409 apt-get install -y -f libc6:amd64 qemu-user-static
410 if [ $? != 0 ]; then sleep 1; continue; fi
411 break
412done
413cd /home/vsoc-01/android-cuttlefish
414dpkg-buildpackage -d -uc -us
415apt-get install -y -f ../cuttlefish-common_*_arm64.deb
416apt-get clean
417usermod -aG cvdnetwork vsoc-01
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700418chmod 660 /dev/vhost-vsock
419chown root:cvdnetwork /dev/vhost-vsock
420
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700421rm /etc/machine-id
422rm /var/lib/dbus/machine-id
423dbus-uuidgen --ensure
424systemd-machine-id-setup
425
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700426systemctl disable sd-dupe
427rm /etc/systemd/system/sd-dupe.service
428rm /usr/local/bin/sd-dupe
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700429rm /usr/local/bin/install-cleanup
430EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700431 chmod +x ${mntdir}/usr/local/bin/install-cleanup
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700432
Tristan Muntsinger34569112019-10-16 22:10:54 -0700433 chroot ${mntdir} /bin/bash << "EOT"
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700434echo "Enabling services..."
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700435systemctl enable led
436systemctl enable sd-dupe
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700437
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700438echo "Creating Initial Ramdisk..."
439update-initramfs -c -t -k "5.2.0"
440mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 -n uInitrd -d /boot/initrd.img-5.2.0 /boot/uInitrd-5.2.0
441ln -s /boot/uInitrd-5.2.0 /boot/uInitrd
442EOT
443
Tristan Muntsinger34569112019-10-16 22:10:54 -0700444 umount ${mntdir}/sys
445 umount ${mntdir}/dev
446 umount ${mntdir}/proc
447 umount ${mntdir}
448
449 # Turn on journaling
450 tune2fs -O ^has_journal ${IMAGE}
451 e2fsck -fy ${IMAGE} >/dev/null 2>&1
452fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700453
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700454if [ ${USE_IMAGE} -eq 0 ]; then
455 # 32GB eMMC size
Tristan Muntsinger34569112019-10-16 22:10:54 -0700456 end_sector=61071326
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700457 device=/dev/${mmc_dev}
458 devicep=${device}
459
460 sgdisk -Z -a1 ${device}
461 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 ${device}
462 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env ${device}
463 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 ${device}
464 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust ${device}
Tristan Muntsinger34569112019-10-16 22:10:54 -0700465 sgdisk -a1 -n:5:32768:${end_sector} -A:5:set:2 -t:5:8305 -c:5:rootfs ${device}
466 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
467 dd if=${IMAGE} of=${devicep}5 bs=1M
468 resize2fs ${devicep}5 >/dev/null 2>&1
469 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700470else
Tristan Muntsinger34569112019-10-16 22:10:54 -0700471 device=$(losetup -f)
472 devicep=${device}p
473 if [ ${FLAGS_p5} -eq ${FLAGS_FALSE} ]; then
474 fs_end=3G
475 end_sector=-
476 fi
477 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
478 # Minimize rootfs filesystem
479 while true; do
480 out=`sudo resize2fs -M ${IMAGE} 2>&1`
481 if [[ $out =~ "Nothing to do" ]]; then
482 break
483 fi
484 done
485 # Minimize rootfs file size
486 block_count=`sudo tune2fs -l ${IMAGE} | grep "Block count:" | sed 's/.*: *//'`
487 block_size=`sudo tune2fs -l ${IMAGE} | grep "Block size:" | sed 's/.*: *//'`
488 sector_size=512
489 start_sector=32768
490 fs_size=$(( block_count*block_size ))
491 fs_sectors=$(( fs_size/sector_size ))
492 part_sectors=$(( ((fs_sectors-1)/2048+1)*2048 )) # 1MB-aligned
493 end_sector=$(( start_sector+part_sectors-1 ))
494 secondary_gpt_sectors=33
495 fs_end=$(( (end_sector+secondary_gpt_sectors+1)*sector_size ))
496 image_size=$(( part_sectors*sector_size ))
497 truncate -s ${image_size} ${IMAGE}
498 e2fsck -fy ${IMAGE} >/dev/null 2>&1
499 fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700500
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700501 # Create final image
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -0700502 if [ $OVERWRITE -eq 1 ]; then
503 tmpimg=${OVERWRITE_IMAGE}
504 else
505 tmpimg=`mktemp`
506 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700507 truncate -s ${fs_end} ${tmpimg}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700508
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700509 # Create GPT
510 sgdisk -Z -a1 ${tmpimg}
511 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 ${tmpimg}
512 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env ${tmpimg}
513 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 ${tmpimg}
514 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust ${tmpimg}
515 sgdisk -a1 -n:5:32768:${end_sector} -A:5:set:2 -t:5:8305 -c:5:rootfs ${tmpimg}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700516
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700517 losetup ${device} ${tmpimg}
518 partx -v --add ${device}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700519
Tristan Muntsinger34569112019-10-16 22:10:54 -0700520 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
521 dd if=${IMAGE} of=${devicep}5 bs=1M
522 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700523fi
Tristan Muntsinger34569112019-10-16 22:10:54 -0700524if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
525 dd if=${idbloader} of=${devicep}1
526fi
527if [ ${FLAGS_p2} -eq ${FLAGS_TRUE} ]; then
528 dd if=${bootenv} of=${devicep}2
529fi
530if [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
531 dd if=${ANDROID_BUILD_TOP}/external/u-boot/u-boot.itb of=${devicep}3
532fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700533if [ ${USE_IMAGE} -eq 1 ]; then
534 chown $SUDO_USER:`id -ng $SUDO_USER` ${tmpimg}
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -0700535 if [ $OVERWRITE -eq 0 ]; then
536 mv ${tmpimg} ${IMAGE}
537 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700538 partx -v --delete ${device}
539 losetup -d ${device}
540fi